#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1000000000000000000LL;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        --a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        b[a[i]] = i;
    }

    vector<long long> cntl(n), cntr(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (b[j] > b[i]) {
                ++cntl[i];
            }
        }
        if (i > 0) {
            cntl[i] += cntl[i - 1];
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            if (b[i] > b[j]) {
                ++cntr[i];
            }
        }
        if (i < n - 1) {
            cntr[i] += cntr[i + 1];
        }
    }

    long long best = INF;
    for (int i = 0; i < n; i++) {
        best = min(best, (i > 0 ? cntl[i - 1] : 0) + (i < n - 1 ? cntr[i + 1] : 0));
    }

    cout << best << endl;

    return 0;
}
