#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> arr;
	vector<int> order(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		--a;
		arr.push_back(a);
		order[arr[i]] = i;
	}

	vector<ll> pref = {0};

	vector<int> storage(n);

	function<int(int)> get_pref_sum = [&](int pos) {
		int ret = 0;
		for (; pos > 0; pos = (pos & (pos - 1))) {
			ret += storage[pos - 1];
		}
		return ret;
	};

	function<int(int, int)> get_sum = [&](int l, int r) {
		return get_pref_sum(r) - get_pref_sum(l);
	};

	function<void(int, int)> add = [&](int pos, int val) {
		for (; pos < n; pos = pos | (pos + 1)) {
			storage[pos] += val;
		}
	};

	for (int i = 0; i < n; ++i) {
		pref.push_back(pref.back() + get_sum(order[i] + 1, n));
		add(order[i], 1);
	}

	vector<ll> suff = {0};
	fill(storage.begin(), storage.end(), 0);

	for (int i = n - 1; i >= 0; --i) {
		suff.push_back(suff.back() + get_sum(0, order[i]));
		add(order[i], 1);
	}

	ll best = INFL;

	for (int i = 0; i < n; ++i) {
		best = min(best, pref[i] + suff[n - i - 1]);
	}

	cout << best << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
