#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 100;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int group = 0;
    group = atoi(validator.group().c_str());
    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN, "m");
    inf.readEoln();
    vector<bool> used(m, false);
    for (int i = 0; i < n; i++)
    {
        string s = inf.readString();
        ensuref(s.size() == m, "|s[%d]| != %d", i + 1, m);
        int st = 0;
        if (i == 0)
        {
            ensuref(s[0] == 'S', "S[1][1] != S");
            st = 1;
        }

        for (int j = st; j < m; j++)
        {
            ensuref(s[j] == '.' || s[j] == 'X', "Incorrect s[%d][%d]", i + 1, j + 1);
            if (s[j] == 'X' && group == 1)
            {
                ensuref(!used[j], "More than one 'X' in %d column", j + 1);
                used[j] = true;
            }
        }
    }
    inf.readEof();
    return 0;
}