#include <bits/stdc++.h>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int k = inf.readInt();
    int l = inf.readInt();
    int r = inf.readInt();
    
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
    }
    int pl = ouf.readInt();
    int pr = ouf.readInt();
    int jl = ans.readInt();
    int jr = ans.readInt();
    if (pl == -1 && pr == -1 && jl == -1 && jr == -1) {
        quitf(_ok, "No pairs");
    }
    if (pl == -1 && pr == -1) {
        quitf(_wa, "Jury has found solution, but participant didn't");
    }
    if (1 > pl || pl > n || 1 > pr || pr > n) {
        quitf(_wa, format("Expected i, j: 1 <= i, j <= n, but found: i = %d, j = %d, n = %d", pl, pr, n).c_str());
    }
    int diffi = std::abs(pl - pr);
    if (0 == diffi || diffi > k) {
        quitf(_wa, format("Expected 1 <= |i - j| <= k, but found: |i - j| = %d, k = %d", diffi, k).c_str());
    }
    int diffe = std::abs(a[pl - 1] - a[pr - 1]);
    if (l > diffe || diffe > r) {
        quitf(_wa, format("Expected l <= |a[i] - a[j]| <= r, but found: l = %d, |a[i] - a[j]| = %d, r = %d", l, diffe, r).c_str());
    }
    quitf(_ok, format("Correct pair: i = %d, j = %d", pl, pr).c_str());
    return 0;
}
