#include "testlib.h"
#include <vector>
#include <algorithm>

const int maxv = 1e9;

const std::vector<int> MAXN = {10,   1000, 100000, 100000, 100000, 100000};
const std::vector<int> MAXV = {maxv, maxv, maxv,   maxv,   maxv,   maxv};
const std::vector<int> MAXL = {maxv, maxv, maxv,   0,      0,      maxv};
const std::vector<int> MAXR = {maxv, maxv, maxv,   0,      maxv,   maxv};
const std::vector<int> MAXK = {10,   1000, 100,    100000, 100000, 100000};

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int group = group = atoi(validator.group().c_str());
    int n = inf.readInt(2, MAXN[group], "n");
    inf.readSpace();
    int k = inf.readInt(1, std::min(MAXK[group], n - 1), "k");
    inf.readSpace();
    int l = inf.readInt(0, MAXL[group], "l");
    inf.readSpace();
    int r = inf.readInt(l, MAXR[group], "r");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
      int x = inf.readInt(1, MAXV[group], format("a[%d]", i + 1));
      if (i + 1 < n) {
        inf.readSpace();
      } else {
        inf.readEoln();
      }
    }
    inf.readEof();
    return 0;
}
