#include <bits/stdc++.h>

std::pair<int, int> exists(const std::set<std::pair<int, int>> &s, int l, int r) {
    auto it = s.lower_bound({l, -1});
    if (it != s.end() && it->first <= r) {
        return *it;
    }
    return {-1, -1};
}

int main() {
    int n, k, l, r;
    std::cin >> n >> k >> l >> r;
    std::vector<int> a(n);
    std::set<std::pair<int, int>> numbers;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        auto xl = exists(numbers, a[i] - r, a[i] - l);
        auto xr = exists(numbers, a[i] + l, a[i] + r);
        if (xl.first != -1) {
            std::cout << xl.second + 1 << ' ' << i + 1 << '\n';
        }
        if (xr.first != -1) {
            std::cout << xr.second + 1 << ' ' << i + 1 << '\n';
            return 0;
        }
        if (i >= k) {
            numbers.erase({a[i - k], i - k});
        }
    }
    std::cout << "-1 -1\n";
    return 0;
}
