#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 5);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int q = atoi(argv[3]);
	int free_cells = atoi(argv[4]);

	cout << n << " " << m << " " << q << "\n";
	vector<pii> order;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			order.push_back({i, j});
		}
	}

	shuffle(order.begin(), order.end());

	order.resize(szof(order) - free_cells);
	for (int i = 0; i < q; ++i) {
		if (i < szof(order)) {
			cout << "c " << order[i].ff + 1 << " " << order[i].ss + 1 << "\n";
		} else {
			char dir = "lrud"[rnd.next(0, 3)];
			int x = rnd.next(0, n - 1);
			int y = rnd.next(0, m - 1);
			cout << dir << " " << x + 1 << " " << y + 1 << "\n";
		}
	}

	return 0;
}