#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1000000000000000000LL;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    long long best = INF;
    for (int x = 0; x < n; x++) {
        long long cur = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (a[i] > a[j] && (a[i] < x || a[j] > x)) {
                    cur++;
                }
            }
        }
        best = min(best, cur);
    }

    cout << best << endl;

    return 0;
}
